#include <vector>
#include <cmath>
#include <allegro.h>
#include "conf.h"
#include "log.h"
#include "bitmap.h"
using namespace std;

int main()
{
    try {
        
        if(0 != allegro_init())
            throw "Unable to intialise allegro.";
        
        Conf conf(Conf::WINDOWED, Conf::HARDWARE);
    
        Bitmap star(load_bitmap("star.tga", 0));
        
        clear_keybuf();
        
        out << "Regular blit.\n";
        
        conf.beginScene();
        conf.clearScreen();
        
        star.blitToScreen(0, 0);
        
        conf.flip();
        
        readkey();
        clear_keybuf();
        
        out << "Circle (scaled) blit.\n";
        
        int i = 0;
        
        while(++i <= 360)
        {
            conf.beginScene();
            conf.clearScreen();
            
            star.circleBlitToScreen(320, 240, 240, 0, i * M_PI / 180);
            
            conf.flip();
            
            rest(15);
        }
        
        readkey();
        clear_keybuf();
        
        out << "Tiled blit.\n";
        
        conf.beginScene();
        conf.clearScreen();
        
        star.tileBlitToScreen(0, 0, 640, 480);
        
        conf.flip();
        
        readkey();
        clear_keybuf();
        
        out << "Rotated blit.\n";
        
        i = 0;
        
        while(++i <= 360)
        {
            conf.beginScene();
            conf.clearScreen();
            
            star.specialBlitToScreen(0, 0, 1, 1, i / 360.0f);
            
            conf.flip();
            
            rest(15);
        }
        
        readkey();
        clear_keybuf();
        
        out << "Pivoted blit.\n";
        
        i = 0;
        
        while(++i <= 360)
        {
            conf.beginScene();
            conf.clearScreen();
            
            star.pivotBlitToScreen(320, 240, -150, -150, i / 360.0f);
            
            conf.flip();
            
            rest(15);
        }
        
        readkey();
        clear_keybuf();
        
    } catch(const char *err)
    {
        Conf::handleCaughtError(err);
    }
}
END_OF_MAIN()
